<?php

/* 
	Project:        Guestbook (Visitor's book)
	File:           jax_guestbook.php (The Guestbook Script)
	Version:        2.2 (multiple database support)
	Interpreter:    PHP 4
	Code:           Andreas John
	Design:         Andreas John
	Homepage:       www.jtr.de/scripting/php
	License:        Copyright (C) 2001, Andreas John (jack@jtr.de)
  
   --------------------------------------------------------------
  
   This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.
		
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public 
	License	along with this program; if not, write to the 
	Free Software Foundation, Inc., 
	59 Temple Place - Suite 330, 
	Boston, MA  02111-1307, USA.

   (or see http://www.fsf.org/copyleft/gpl.html)   
*/

// Globale Variable (mssen evtl. angepasst werden)
require ( "globals.inc.php" );

// Datei fr die jeweilige Sprache einbinden
require ( "language/" .$languagepack . ".inc.php" );
	
if ( $data_source == "mysql" )
{
	// Klasse fr die Datenbankuntersttzung einbinden
	require ( "mysql.inc.php" );

	// Objekte fr den Datenbankzugriff vorbereiten
	$db				= new mysql;
	$db->name		= $guestbookfile;
	$db->server		= $db_server;
	$db->login		= $db_login;
	$db->password	= $db_password;
	$db->database	= $db_database;
	$db->init();
	
	$bf				= new mysql;
	$bf->name		= $blocking_file;
	$bf->server		= $db_server;
	$bf->login		= $db_login;
	$bf->password	= $db_password;
	$bf->database	= $db_database;
	$bf->init();	
}

if ( $data_source == "csvfile" )
{
	// Klasse fr die CSV-Textdatei einbinden
	require ( "csvfile.inc.php" );

	// Objekte fr den Dateizugriff vorbereiten
	$db			= new csvfile;
	$db->name	= $guestbookfile;
	$db->init();	

	$bf			= new csvfile;
	$bf->name	= $blocking_file;
	$bf->init();
}

?>

<html>
  <head>
  <title><?php echo $htmltitle; ?></title>
  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
  <link rel="stylesheet" href="<?php echo $css_file; ?>">
  <meta http-equiv="expires" content="1">
</head>

<? 
// JavaScript-Prfroutinen fr das Eingabeformular...
require "tests.js.inc.php";  
?>

<body link="#FFFFFF" vlink="#FFFFFF" alink="#FFFFFF">
<p>&nbsp;</p>
<h3 align="center" class="guestbook"><?php echo $htmltitle; ?></h3>

<?php

	function block_ip()
	// Aufgabe:  Sperrt die IP-Adresse eines unfltigen Besuchers
	//           fr eine kurze Zeit

	{
		global $blocking_period, $bf, $REMOTE_ADDR;
		
		// Sperrfrist (mehr als 3 Stunden machen keinen Sinn!)
		$stamp = intval( date( "mdG" ) ) + $blocking_period;	
		
		$dummy = array();
		$dummy["ip"] = strval( $REMOTE_ADDR );
		$dummy["timestamp"] = $stamp;
		
		$bf->append( $dummy );
	}

	function check_ip( )
	// Aufgabe:  berprft, ob die IP-Adresse des Surfers zulssig ist
	//
	// Eingabe:  keine
	//
	// Rckgabe: keine
	{
		global $REMOTE_ADDR, $_like_you_anyway, $bf;
		
		$stamp = intval( date( "mdG" ) );

		$position = $bf->find_entry( $REMOTE_ADDR );

		$entries = array();
		$bf->get_entry( $position, $entries );

	   if ( ($entries["ip"] == $REMOTE_ADDR) and 
	        ($stamp <= $entries["timestamp"]) )
		{ 
			echo $_like_you_anyway; 
			exit(); 
		}
	}	

	function email_notification( )
	// Aufgabe:  Benachrichtigt den Webmaster per e-mail ber
	//           den Gstebucheintrag
	//
	// Eingabe:  keine
	//
	// Rckgabe: keine
	{
		global $SERVER_NAME, $PATH_INFO, $administrator_address, $_new_entry;

		$mailheader = 
		trim( "From: ".$_guestbook." <postmaster@".$SERVER_NAME.">\n"
		. "Reply-To: postmaster@".$SERVER_NAME."\n"
		. "X-Mailer: PHP " . phpversion() );
   		    
		$gb_url = "http://".$SERVER_NAME.$PATH_INFO;

		$message	= trim( $_new_entry."\n\n".$gb_url." !\n" );
		$subject	= trim( $_new_entry."\n" );
		$email	= trim( $administrator_address );

		mail( $email, $subject, $message, $mailheader );
	}

//----------------------------------------------------------------------------
//	Gstebucheintrag wurde gesendet, speichern!
//----------------------------------------------------------------------------

	if ( $action == "post" )
	{
		check_ip();
		$msg = $message;

		// Zeilenumbrche aus der Nachricht entfernen!!
		$msg = ereg_replace("(\r\n|\n|\r)", "<br>", $msg);

		// HTML "Script" - Tag entfernen
		if ( ereg("[<][Ss][Cc][Rr][Ii][Pp][Tt]", $msg) )
		{
			echo $_nice_try;
			block_ip();
			exit();
		}

		// Alle HTML-Tags entfernen?
		if ( $filter_html == true )
		{
			$msg = strip_tags( $msg );
		}


		// Nachricht evtl. krzen!
		$msg = substr( $msg, 0, $max_message_size );

		if ( $filter_badwords == true )
		{
			// Liste mit den Schimpfworten einlesen
			$wordlist = file ( "language/" . $languagepack . ".insults.txt" );

			$words = array_values( $wordlist );

			$insults = 0;
			$dummy = strtolower( $msg );
			foreach ( $words as $swearword )
			{
				// Enthlt die Nachricht eines der Schimpfworte?
				if ( strstr( $dummy , trim($swearword) ) )
				{ 
					$insults++;
					// Bei berschreiten der Schmerzgrenze den Benutzer sperren
					if ( $insults >= $insults_tolerance )
					{ 
						$msg = ""; 
						block_ip();
						break;
					}
				}
			}
		}


		if ( $msg != "" && $name != "" ) 
		{ 
			$new_entry = array();
			$new_entry["date"]		= date( "Y-m-d" );
			$new_entry["time"]		= date( "H:i:s" );
			$new_entry["ip"]			= $REMOTE_ADDR;
			$new_entry["name"]		= strip_tags( $name );
			$new_entry["mail"]		= strip_tags( $mail );
			$new_entry["age"]			= strip_tags( $age );
			$new_entry["location"]	= strip_tags( $location );
			$new_entry["homepage"]	= strip_tags( $homepage );
			$new_entry["icq"]			= strip_tags( $icq );
			$new_entry["message"]	= $msg;
			$db->append( $new_entry );
			
			if ( $administrator_notification == true )
			{
				email_notification( );
			}

			if ( $filter_multiposting == true ) 
			{ 
				block_ip(); 
			}
		}

		// Letzte Seite (die mit neuem Eintrag) anzeigen!
		$page = 1;			
	}

//----------------------------------------------------------------------------
// 	Aktuelle Gstebuchseite anzeigen! (Standard)
//----------------------------------------------------------------------------

	if ( empty( $page ) ) { $page = 1; }
	$entries = $db->entries();

	// Seitenaufteilung berechnen
	$maxpages = ceil( $entries / $entries_per_page );

	if ( $page < $maxpages ) 
	  { $nextpage = $page+1; } 
	else 
	  { $nextpage = $maxpages; }

	$lastpage = $page-1;
	

require ( "form.inc.php" );

$pagenavigation = <<<NAV
<p align="center" id="page_nav">&lt; <a href="$PHP_SELF?page=$lastpage">$_last</a> | $page $_of $maxpages | 
<a href="$PHP_SELF?page=$nextpage">$_next</a> &gt;</p>
NAV;

echo $pagenavigation;

?>

<table width="75%" border="0" align="center">
  <tr> 
    <td>&nbsp;</td>
    <td>&nbsp;</td>
  </tr>

<?php

	// Aufgabe:  Gibt einen Gstebucheintrag formatiert aus
	//
	// Eingabe:  $token   : Array mit den Einzeleintrgen
	//
	// Rckgabe: Fr die Ausgabe formatierter String...
	//
	function showentry( $entry )
	{
		global $languagepack, $_yearsold, $_from, $input_icq;
		
		$date = $entry["date"];
		$time	= $entry["time"];
		$name	= $entry["name"];
		$mail	= $entry["mail"];
		$age	= $entry["age"];
		$state= $entry["location"];
		$url	= $entry["homepage"];
		$icq  = $entry["icq"];

		// URL gegebenenfalls um "http://" ergnzen
		if ( !empty( $url ) && (!eregi( "http://", $url )) ) 
		{ 
			$url = "http://".$url; 
		}
		
		$msg	= $entry["message"];

		// Smileys konvertieren!
		$msg = eregi_replace(":-\)\)|:\)\)|:biggrin:",
		'<img src="smileys/biggrin.gif" border="0">',$msg);
		
		$msg = eregi_replace(":-\)|:\)|:smile:",
		'<img src="smileys/smile.gif" border="0">',$msg);

		$msg = eregi_replace(":O\)|:o\)",
		'<img src="smileys/smile2.gif" border="0">',$msg);
		
		$msg = eregi_replace(";-\)|;\)|:wink:",
		'<img src="smileys/wink.gif" border="0">',$msg);
		
		$msg = eregi_replace(":-\(|:\(|:sad:",
		'<img src="smileys/sad.gif" border="0">',$msg);
		
		$msg = eregi_replace(":O\(|:o\(",
		'<img src="smileys/sad2.gif" border="0">',$msg);
		
		$msg = eregi_replace(":-D|:D|:happy:",
		'<img src="smileys/happy.gif" border="0">',$msg);
		
		$msg = eregi_replace(":heart:",
		'<img src="smileys/heart.gif" border="0">',$msg);
		
		$msg = eregi_replace(":-P|:P|:tongue:",
		'<img src="smileys/tongue.gif" border="0">',$msg);
		
		$msg = eregi_replace("8-\)|8\)|:cool:",
		'<img src="smileys/cool.gif" border="0">',$msg);
		
		$msg = eregi_replace(":-\(|:\(|:weep:",
		'<img src="smileys/weep.gif" border="0">',$msg);
		
		$msg = eregi_replace(":-o|:o|:astonished:",
		'<img src="smileys/surprised.gif" border="0">',$msg);

		// Das Datum muss evtl. noch ins deutsche Format gebracht werden
		if ( $languagepack == "German" )
		{ 
			$gdate	= explode( '-' , $date );
			$date   = $gdate[2] . '.' . $gdate[1] . '.' . $gdate[0];
		}		
		
		// Ausgabestring zusammenschnipseln
		
		$outputstr = '<p id="guestbook_date">' . $date . " "
		. $time . "</p>"
		. '<p id="guestbook_name">';
		
		if ((!empty($icq)) && ($input_icq == true) ) 
		{ 
			$outputstr .= '<A HREF="http://wwp.icq.com/scripts/search.dll?to='.$icq.'"><IMG BORDER=0 SRC="http://wwp.icq.com/scripts/online.dll?icq='.$icq.'&img=5" ALT="ICQ Status"></A>';
		}
		
		$outputstr .= '<a href="mailto:' . $mail . '">'
		. $name . "</a> ";
			
		if ( !empty($age) OR !empty($state) )
		{ $outputstr .=  " ( "; }
		
		if (!empty($state))
			if (!empty($age))
			{
				$outputstr .= " $age $_yearsold, $_from $state ) "; 
			}
		  	else 
		  	{ 
		  		$outputstr .= " $_from $state ) "; 
		  	}
		else
			if (!empty($age) )
			{
				$outputstr .= " $age $_yearsold ) ";
			}
		  	
		if (!empty($url))
		{
			$outputstr .= ' | <a href="' . $url 
			. '" target="_blank">' . $url . "</a>\n"; 
		}
			
		$outputstr .= '<br><br></p><p id="guestbook_message">'
		. $msg . "</p><p>&nbsp;</p>";

		return $outputstr;
	}

//----------------------------------------------------------------------------
// 	Eintrge auf aktueller Seite anzeigen
//----------------------------------------------------------------------------  

	// Zeile in der Datei, ab der die Eintrge ausgegeben werden
	$first_entry = $entries - ( $page * $entries_per_page ) + 1;
	if ($first_entry < 1) { $first_entry = 1; }

	// Zeile in der Datei, bis zu der die Eintrge ausgegeben werden
	$last_entry = $entries - ( ($page-1) * $entries_per_page );
	if ($last_entry < 1) { $last_entry = 1; }
	
// Eintrge nach LIFO-Prinzip sortiert ausgeben
	
	$entrynum = $last_entry;

	$entry = array();
	$db->get_entrylist( $first_entry-1, $last_entry-1, $entry );

	$keys = array_keys( $entry );
	$keys = array_reverse( $keys );

	$i = $last_entry;
	foreach ($keys as $key)
	{
		echo "<tr>\n".'  <td valign="top" id="guestbook_counter">'
		. ($i).":&nbsp;</td>\n  <td>"
		. showentry( $entry[$key] ) . "</td></tr>\n";
		$i--;
	}

?>
  <tr> 
    <td>&nbsp;</td>
    <td>&nbsp;</td>
  </tr>
</table>

<?php echo $pagenavigation; ?>

<p>&nbsp;</p>
<p><font size="1" color="#BBBBBB">Guestbook v2.2 by Jack (tR), 
<a href="http://www.jtr.de/scripting/php">www.jtr.de/scripting/php</a>
</font></p>

</body>
</html>
